//-------------------------------------------------------------------------------
// Functions for creating bills.
//-------------------------------------------------------------------------------

function InitializeCreateBillDlg()
{
   txtSubtotalDue.setText( "$0.00" );
   txtCalcSalesTax.setText( "$0.00" );
   txtTotalDue.setText( "$0.00" );

   PopulateMenuItemList( lstMenuItem1 );
   PopulateMenuItemList( lstMenuItem2 );
   PopulateMenuItemList( lstMenuItem3 );
   PopulateMenuItemList( lstMenuItem4 );
   PopulateMenuItemList( lstMenuItem5 );
   PopulateMenuItemList( lstMenuItem6 );
   PopulateMenuItemList( lstMenuItem7 );
   PopulateMenuItemList( lstMenuItem8 );
   PopulateMenuItemList( lstMenuItem9 );
   PopulateMenuItemList( lstMenuItem10 );
}

function PopulateMenuItemList( %list )
{
   %list.clear();
   %list.add("-- SELECT A MENU ITEM --", 0);
   for( %i=0; %i < $menuItemList.nItems; %i++) 
   {
      %list.add( $menuItemList.lstItems[%i].name, %i + 1 );
   }

   %list.setSelected( 0 );
}

function CalculateBillTotal()
{
   %total = 0.0;
   %total += GetMenuItemValue( lstMenuItem1 );
   %total += GetMenuItemValue( lstMenuItem2 );
   %total += GetMenuItemValue( lstMenuItem3 );
   %total += GetMenuItemValue( lstMenuItem4 );
   %total += GetMenuItemValue( lstMenuItem5 );
   %total += GetMenuItemValue( lstMenuItem6 );
   %total += GetMenuItemValue( lstMenuItem7 );
   %total += GetMenuItemValue( lstMenuItem8 );
   %total += GetMenuItemValue( lstMenuItem9 );
   %total += GetMenuItemValue( lstMenuItem10 );

   txtSubtotalDue.setText( FormatCashOutput( %total ) );

   %tax = CalcTax( %total );
   txtCalcSalesTax.setText( FormatCashOutput( %tax ) );

   %cash = FormatCashOutput( %total + %tax );
   txtTotalDue.setText( %cash );
}

function GetMenuItemValue( %list )
{
   %text = %list.getText();
   for( %i=0; %i < $menuItemList.nItems; %i++) 
   {
      if( %text $= $menuItemList.lstItems[%i].name ) 
         return $menuItemList.lstItems[%i].price;
   }
   return 0.0;
}

function CalcTax( %total )
{
   return %total * 0.05;
}

function ItemCost( %list, %text )
{
   %val = GetMenuItemValue( %list );
   %cost = FormatCashOutput( %val );
   %text.setText( %cost );
}

function lstMenuItem1::onSelect( %this, %id, %text ) { ItemCost( lstMenuItem1, txtCostMenuItem1 ); CalculateBillTotal(); }
function lstMenuItem2::onSelect( %this, %id, %text ) { ItemCost( lstMenuItem2, txtCostMenuItem2 ); CalculateBillTotal(); }
function lstMenuItem3::onSelect( %this, %id, %text ) { ItemCost( lstMenuItem3, txtCostMenuItem3 ); CalculateBillTotal(); }
function lstMenuItem4::onSelect( %this, %id, %text ) { ItemCost( lstMenuItem4, txtCostMenuItem4 ); CalculateBillTotal(); }
function lstMenuItem5::onSelect( %this, %id, %text ) { ItemCost( lstMenuItem5, txtCostMenuItem5 ); CalculateBillTotal(); }
function lstMenuItem6::onSelect( %this, %id, %text ) { ItemCost( lstMenuItem6, txtCostMenuItem6 ); CalculateBillTotal(); }
function lstMenuItem7::onSelect( %this, %id, %text ) { ItemCost( lstMenuItem7, txtCostMenuItem7 ); CalculateBillTotal(); }
function lstMenuItem8::onSelect( %this, %id, %text ) { ItemCost( lstMenuItem8, txtCostMenuItem8 ); CalculateBillTotal(); }
function lstMenuItem9::onSelect( %this, %id, %text ) { ItemCost( lstMenuItem9, txtCostMenuItem9 ); CalculateBillTotal(); }
function lstMenuItem10::onSelect( %this, %id, %text ) { ItemCost( lstMenuItem10, txtCostMenuItem10 ); CalculateBillTotal(); }

function CreateNewBill()
{
   if( lstMenuItem1.getSelected() )  %lstItems[0] = lstMenuItem1.getText();
   if( lstMenuItem2.getSelected() )  %lstItems[1] = lstMenuItem2.getText();
   if( lstMenuItem3.getSelected() )  %lstItems[2] = lstMenuItem3.getText();
   if( lstMenuItem4.getSelected() )  %lstItems[3] = lstMenuItem4.getText();
   if( lstMenuItem5.getSelected() )  %lstItems[4] = lstMenuItem5.getText();
   if( lstMenuItem6.getSelected() )  %lstItems[5] = lstMenuItem6.getText();
   if( lstMenuItem7.getSelected() )  %lstItems[6] = lstMenuItem7.getText();
   if( lstMenuItem8.getSelected() )  %lstItems[7] = lstMenuItem8.getText();
   if( lstMenuItem9.getSelected() )  %lstItems[8] = lstMenuItem9.getText();
   if( lstMenuItem10.getSelected() ) %lstItems[9] = lstMenuItem10.getText();

   CommandToServer( 'SpawnNewBill',
                    txtCalcSalesTax.getText(), txtSubtotalDue.getText(), txtTotalDue.getText(), 
                    %lstItems[0], %lstItems[1], %lstItems[2], %lstItems[3], %lstItems[4], 
                    %lstItems[5], %lstItems[6], %lstItems[7], %lstItems[8], %lstItems[9] );
}

//-------------------------------------------------------------------------------
// Functions for paying bills.
//-------------------------------------------------------------------------------

function InitializePayBillDlg( %bill,
                               %lstItems0, %lstItems1, %lstItems2, %lstItems3, %lstItems4,
                               %lstItems5, %lstItems6, %lstItems7, %lstItems8, %lstItems9,
                               %subtotal, %tax, %tip, %total, %paid )
{
   txtMenuItem1.setText( %lstItems0 );
   txtMenuItem2.setText( %lstItems1 );
   txtMenuItem3.setText( %lstItems2 );
   txtMenuItem4.setText( %lstItems3 );
   txtMenuItem5.setText( %lstItems4 );
   txtMenuItem6.setText( %lstItems5 );
   txtMenuItem7.setText( %lstItems6 );
   txtMenuItem8.setText( %lstItems7 );
   txtMenuItem9.setText( %lstItems8 );
   txtMenuItem10.setText( %lstItems9 );

   if( %lstItems0 !$= "" ) txtPayMenuItem1.setText( GetItemPrice( $menuItemList, %lstItems0 ) );
   else txtPayMenuItem1.setText("");
   if( %lstItems1 !$= "" ) txtPayMenuItem2.setText( GetItemPrice( $menuItemList, %lstItems1 ) );
   else txtPayMenuItem2.setText("");
   if( %lstItems2 !$= "" ) txtPayMenuItem3.setText( GetItemPrice( $menuItemList, %lstItems2 ) );
   else txtPayMenuItem3.setText("");
   if( %lstItems3 !$= "" ) txtPayMenuItem4.setText( GetItemPrice( $menuItemList, %lstItems3 ) );
   else txtPayMenuItem4.setText("");
   if( %lstItems4 !$= "" ) txtPayMenuItem5.setText( GetItemPrice( $menuItemList, %lstItems4 ) );
   else txtPayMenuItem5.setText("");
   if( %lstItems5 !$= "" ) txtPayMenuItem6.setText( GetItemPrice( $menuItemList, %lstItems5 ) );
   else txtPayMenuItem6.setText("");
   if( %lstItems6 !$= "" ) txtPayMenuItem7.setText( GetItemPrice( $menuItemList, %lstItems6 ) );
   else txtPayMenuItem7.setText("");
   if( %lstItems7 !$= "" ) txtPayMenuItem8.setText( GetItemPrice( $menuItemList, %lstItems7 ) );
   else txtPayMenuItem8.setText("");
   if( %lstItems8 !$= "" ) txtPayMenuItem9.setText( GetItemPrice( $menuItemList, %lstItems8 ) );
   else txtPayMenuItem9.setText("");
   if( %lstItems9 !$= "" ) txtPayMenuItem10.setText( GetItemPrice( $menuItemList, %lstItems9 ) );
   else txtPayMenuItem10.setText("");

   txtPaySubtotal.setText( %subtotal );
   txtPaySalesTax.setText( %tax );
   sldTip.setText( %tip );
   txtPayTotal.setText( %total );

   txtStaticBillID.setText( %bill );

   if( %paid == true )
   {
      btnPayBillOk.setVisible(false);
      btnPayBillCancel.setVisible(false);
      sldTip.setVisible(false);

      btnPayBillPaidOk.setVisible(true);

      txtPayTip.setText( "GRATUITY:   $" @ sldTip.getText() );
      bmpBillPaid.setVisible(true);
   }
   else {
      btnPayBillOk.setVisible(true);
      btnPayBillCancel.setVisible(true);
      sldTip.setVisible(true);

      btnPayBillPaidOk.setVisible(false);

      txtPayTip.setText( "GRATUITY:   $" );
      bmpBillPaid.setVisible(false);
   }
}

function CalcTotalWithTip() 
{
   %total = sldTip.getText() + getSubStr( txtPaySubtotal.getText(), 1, 999 ) + getSubStr( txtPaySalesTax.getText(), 1, 999 );
   %formatted = FormatCashOutput( %total );
   txtPayTotal.setText( %formatted );
}

function PayBill() 
{
   %total = sldTip.getText() + getSubStr( txtPaySubtotal.getText(), 1, 999 ) + getSubStr( txtPaySalesTax.getText(), 1, 999 );
   %formatted = FormatCashOutput( %total );

echo( "PAY:" SPC txtStaticBillID.getText() SPC sldTip.getText() SPC %formatted );
   CommandToServer( 'ProcessBillPayment', txtStaticBillID.getText(), sldTip.getText(), %formatted );
}

function clientCmdWarnCantPay(%pos, %paid, %total)
{
   dlgNotEnoughMoney.setVisible(true);

   txtNotEnoughMoney.setText( "YOU HAVE RUN OUT OF MONEY.\nYOU OWE" SPC FormatCashOutput(%total) SPC "BUT COULD ONLY PAY" SPC FormatCashOutput(%paid) @ "." );

   // Play a ding sound.
   %soundDing = "~/data/sound/cogmac/ding.wav";
   PlaySound( %soundDing, %pos );
}

//-------------------------------------------------------------------------------
// Functions for earning money.
//-------------------------------------------------------------------------------

function InitializeEarnMoneyDlg( %payer, %payee, %subtotal, %tip, %totalEarned, %pos )
{
   txtEarnedMoneyFailedHeader.setVisible(false);
   txtEarnedMoneySubtotal.setVisible(true);
   txtEarnedMoneyTip.setVisible(true);
   txtEarnMoneyDivider.setVisible(true);
   txtEarnedMoneyTotal.setVisible(true);

   txtEarnMoneyHeader.setText( "YOU HAVE EARNED:" );

   txtEarnedMoneySubtotal.setText( FormatCashOutput(getSubStr(%subtotal, 1, 255) * 0.50) SPC "  (50% OF" SPC %subtotal @ ")" );
   txtEarnedMoneyTip.setText( "+" SPC FormatCashOutput(%tip) SPC "  (TIP)" );

   %total = %tip + (getSubStr(%subtotal, 1, 255) * 0.50);
   txtEarnedMoneyTotal.setText( FormatCashOutput(%total) );

   // Play a pay sound.
   %soundPay = "~/data/sound/cogmac/cashreg.wav";
   PlaySound( %soundPay, %pos );
}









